unit uFormularioEstatico;

{$mode delphi}

{$DEFINE DEBUG}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  maskedit, uFormularioBase, ucosa, ufechas, contnrs, uFormularioAutomatico, uvisordetabla;

type

  { TFormularioEstatico }

  TFormularioEstatico = class(TFormularioBase)

    procedure OnChange(Sender: TObject);
    procedure OnEnter(Sender: TObject);
    procedure OnExit(Sender: TObject);

  private
    { private declarations }

  protected
    //Es una lista de todos los dataCell involucrados en la edicion,
    //hace el vinculo entre los controles y los datacell mediante la propiedad
    //tag del control y i en indice en dr_local
    dr_local: TDataRowOfCosa;

  public
    { public declarations }

    IgnoranceList: TFPStringHashTable;
    IgnoreTable:string;
    IgnoreList:string;

    constructor Create(TheOwner: TComponent); override;

    function AsignarEventosYCargarControlesEstandar: boolean; virtual;
    procedure CargarControlesEspecificos; virtual; abstract;
    procedure QueryInical;virtual;abstract;

    procedure SetEvents();virtual;abstract;

  end;

var
  FormularioEstatico: TFormularioEstatico;

implementation

{$R *.lfm}

{ TFormularioEstatico }

constructor TFormularioEstatico.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  dr_local:= TDataRowOfCosa.Create;
end;



function TFormularioEstatico.AsignarEventosYCargarControlesEstandar: boolean;
var
  i, j, tag: integer;
  dt: TDataTableOfCosa;
  dc: TDataColumnOfCosa;
  c: TComponent;

  bval: boolean;
  fecha: TFecha;
  dcll: TDataCellOfCosa;

  lstA, lstB: TStringList;
  b: String;
  a: Integer;
  aTop: Integer;
  aLeft: Integer;
  dta: TDataTableOfCosa;
  Grid: TEditorDataGridControl;
begin
  //if (IgnoreTable='') and (IgnoreList = '') then
  //  exit;

  Result:=true;

  self.SetEvents();

  for i := 0 to dataSet.DataTableListCount - 1 do
  begin
    dt := dataSet.DataTableList[i];

    lstB:= TStringList.Create;
    lstB.CommaText:=self.IgnoranceList.Items[dt.TableName];
    lstB.CaseSensitive := False;

    b:=lstB.CommaText;

    //INICIALIZO EL DT_LOCAL
    (*
    for j := 0 to dt.DataColumnListCount - 1 do
    begin
      dr_local.AddDataCell(nil);
    end;
    *)
    if (lstB.CommaText<>'*') then
    begin
      for j := 0 to dt.DataColumnListCount - 1 do
      begin
        dc := dt.DataColumnList[j];
        if (lstB.IndexOf(dc.ColumnName) < 0 ) then
        begin

          if (dc.ColumnName='ncronicasopt') then
            a:=1;

          c := self.FindComponent(Copy(dt.TableName,4,Length(dt.TableName)) +'_'+dc.ColumnName);
          {$IFDEF DEBUG}
          if not Assigned(c) then
            raise Exception.Create('No existe control para el campo ' + Copy(dt.TableName,4,Length(dt.TableName)) +'_'+dc.ColumnName);
          {$ENDIF}

          //se asume que las tablas tienen un solo datarow
          dcll := dt.DataRowList[0].DataCellList[j];

          if (dt.TableName='dt_TListFuenteAleatoria') and (dc.ColumnName='lst') then
            dta:= dcll.DataRowOwner.DataTableOwner;


          tag:=dr_local.AddDataCell(dcll, false);
          c.Tag := tag;

          TWinControl(c).OnEnter := OnEnter();
          TWinControl(c).OnExit := OnExit();

          dta:= dcll.DataRowOwner.DataTableOwner;

          if c.Name = 'TSalaDeJuego_escenarios' then
            a:=1;

          if (dc.DataType is TDataTypeBooleanOfCosa) then
          begin



            {$IFDEF DEBUG}
            if (not (c is TCheckBox)) and (not (c is TRadioGroup)) then
              raise Exception.Create(dc.ColumnName + ' VER');
            {$ENDIF}

            dc.DataType.Eval(dcll.sval, @bval);

            if c is TCheckBox then
            begin
              //TCheckBox(c).OnChange := OnChange();

              //ESTO SE HACE PARA QUE SE DISPARE EL EVENTO ASIGNADO:
              TCheckBox(c).Checked := not bval;
              TCheckBox(c).Checked := bval;
            end;

            if c is TRadioGroup then
              if bval then
                TRadioGroup(c).ItemIndex:=1
              else
                TRadioGroup(c).ItemIndex:=0;
          end

          else if (dc.DataType is TDataTypeDateOfCosa) then
          begin
            {$IFDEF DEBUG}
            if not (c is TMaskEdit) then
              raise Exception.Create(dc.ColumnName + ' VER');
            {$ENDIF}

            TMaskEdit(c).Text := dcll.sval;
          end

          else if (dc.DataType is TDataTypeIntegerOfCosa) or
                  (dc.DataType is TDataTypeStringOfCosa)  or
                  (dc.DataType is TDataTypeDoubleOfCosa)  then
          begin
            {$IFDEF DEBUG}
            if not (c is TEdit) then
              raise Exception.Create(dc.ColumnName + ' VER');
            {$ENDIF}

            TEdit(c).Text := dcll.sval;
          end

          else if (dc.DataType is TDataTypeListOfCosa) then
          begin
            if not (c is TPanel) then
              raise Exception.Create(dc.ColumnName + ' VER');

            Grid:=TEditorDataGridControl.Create(dt.TableName+'_'+dc.ColumnName, self, TPanel(c), dc, dcll, dt.GetDataColumnList().ItemListClaseDeCosa);

            Grid.AVT_DefaultEditor.Top:=0;
            Grid.AVT_DefaultEditor.Left:=0;
            Grid.AVT_DefaultEditor.ImageList:=DataModule2.ImageList1;

            Grid.AButton.Top:=0;
            Grid.AButton.Left:=TEditorDataGridControl(c).Width+5;

            Grid.OnEnter:=OnEnter();
            Grid.OnExit:=OnExit();

          end

          else if dc.DataType is TDataTypeArchiRefOfCosa then
          begin
            TEdit(c).Text := dcll.sval;
          end;


          //else if (DataColumn.DataType is TDataTypeCardinalOfCosa) or
          //        (DataColumn.DataType is TDataTypeDoubleOfCosa)   or
          //        (DataColumn.DataType is TDataTypeStringOfCosa)   then
          //  Control:=TEditorTEditControl.Create(self.ScrollBox, DataColumn, DataCell)

          //else if (DataColumn.DataType is TDataTypeDAOfBooleanOfCosa) or
          //        (DataColumn.DataType is TDataTypeDAOfDoubleOfCosa)  or
          //        (DataColumn.DataType is TDataTypeDAOfIntegerOfCosa) or
          //        (DataColumn.DataType is TDataTypeDAOfStringOfCosa)  then
          //  Control:=TEditorTMemoControl.Create(self.ScrollBox, DataColumn, DataCell)


            //else if (DataColumn.DataType is TDataTypeDataRowOfCosa) then
            //begin

            //else if (DataColumn.DataType is TDataTypeListOfCosa) then
            //begin
            //  Control:=TEditorDataGridControl.Create(self.ScrollBox, DataColumn, DataCell, DataTable.GetDataColumnList().ItemListClaseDeCosa);
            //end

            //else if (DataColumn.DataType is TDataTypeReferenciaOfCosa) then
            //begin
            //  if (DataColumn.DataType.ClaseDeCosa<>nil) then
            //    Control:=TEditorTComboBoxControl.Create(self.ScrollBox, DataColumn, DataCell);
            //end

            //else if (DataColumn.DataType is TDataTypeArchiRefOfCosa) then
            //begin
            //  Control:=TEditorTOpenDialogControl.Create(self.ScrollBox, DataColumn, DataCell);
            //end
            //;
        end;
      end;
    end;
  end;
end;

procedure TFormularioEstatico.OnChange(Sender: TObject);
begin
  self.hayCambios := True;
end;

procedure TFormularioEstatico.OnEnter(Sender: TObject);
begin
  if Sender is TCustomEdit then
    OnEnterVal := TMaskEdit(Sender).Text;
end;

procedure TFormularioEstatico.OnExit(Sender: TObject);
var
  dcll: TDataCellOfCosa;
  sval: TCaption;
begin
  dcll := dr_local.DataCellList[TWinControl(Sender).Tag];

  if      Sender is TEdit       then sval:=TEdit(Sender).Text
  else if Sender is TCheckBox   then sval:=BoolToStr(TCheckBox(Sender).Checked)
  else if Sender is TRadioGroup then sval:=IntToStr(TRadioGroup(Sender).ItemIndex);

  if dcll.sval <> sval then
  begin
    dcll.sval:=sval;
    hayCambios:=True;
  end;

  (*
  if (Sender is TCustomEdit) and (TMaskEdit(Sender).Text <> OnEnterVal) then
  begin
    dcll.sval := TMaskEdit(Sender).Text;
    writeln(dcll.sval);
    hayCambios := True;
  end;
  *)
end;

end.

