unit uConversions;

interface

uses
  Classes, SysUtils, xmatdefs;

type

  { TDataConversion }

  { TDataConversionOfCosa }

  TDataConversionOfCosa=class
    nResult,nVariable1,nVariable2:string;
    Active:boolean;
    DataColumnOwner:TClass;
    constructor Create(); overload;
    constructor Create({xDataColumnOwner: Tclass ;}xnVariable1,xnVariable2,xnResult:string); overload;
    procedure Convert(theOperator,vVariable1,vVariable2:string;var vResult:string); overload;
    procedure Convert(vVariable1,vVariable2:string;var vResult:string);virtual; abstract; overload;

    procedure Free;
  end;

  { TSumConversion }

  TSumDataConversionOfCosa=class(TDataConversionOfCosa)
     procedure Convert(vVariable1,vVariable2:string;var vResult:string);override;
  end;

  { TListConversion }

  { TListDataConversionOfCosa }

  TListDataConversionOfCosa=class(TList)
  protected
    function GetItem(Index: Integer): TDataConversionOfCosa;
  public
    function Add(DataConversion: TDataConversionOfCosa):integer;
    function FindVariableByName(xVariableName:string; var xConverter:TDataConversionOfCosa):Boolean ;
    property Items[Index: Integer]: TDataConversionOfCosa read GetItem;

    procedure Free;
  end;

implementation

uses
  ucosa;

{ TListConversion }

function TListDataConversionOfCosa.GetItem(Index: Integer): TDataConversionOfCosa;
begin
  Result:=TDataConversionOfCosa(inherited Items[Index]);
end;

function TListDataConversionOfCosa.Add(DataConversion: TDataConversionOfCosa): integer;
begin
  inherited Add(DataConversion);
end;

function TListDataConversionOfCosa.FindVariableByName(xVariableName: string;
  var xConverter: TDataConversionOfCosa): Boolean;
var
  i:integer;
begin
  Result:=False;
  xConverter := nil;
  for i:=0 to self.Count-1 do
  begin
    if self.Items[i].nResult = xVariableName then
      begin
        xConverter:=self.Items[i];
        Result:=True;
        Break;
      end;
  end;
end;

procedure TListDataConversionOfCosa.Free;
var
  i: Integer;
begin
  for i:=0 to Count-1 do
    Items[i].Free;

  inherited Free;
end;

{ TDataConversion }

constructor TDataConversionOfCosa.Create();
begin
  self.Active:=false;
end;

constructor TDataConversionOfCosa.Create({xDataColumnOwner: Tclass; }xnVariable1,
  xnVariable2, xnResult: string);
begin
  inherited Create();
//  self.DataColumnOwner:=xDataColumnOwner;
  self.nResult:=xnResult;
  self.nVariable1:=xnVariable1;
  self.nVariable2:=xnVariable2;
end;

procedure TDataConversionOfCosa.Convert(theOperator,vVariable1,vVariable2:string;var vResult:string);
begin
  vResult:=vVariable1+theOperator+vVariable2;
end;

procedure TDataConversionOfCosa.Free;
begin
  DataColumnOwner:=nil;
end;

{ TSumDataConversion }

procedure TSumDataConversionOfCosa.Convert(vVariable1,vVariable2:string;var vResult:string);
begin
  inherited Convert('+',vVariable1,vVariable2,vResult);
end;

end.

